## golf 601.4.41

=== Makefile ===
#SPDX-License-Identifier: Apache-2.0
#Copyright 2018-2025 Gliim LLC.  
#Licensed under Apache License v2. See LICENSE file.
#On the web http://golf-lang.com/ - this file is part of Golf framework.

#makefile for Golf

.DEFAULT_GOAL=build
SHELL:=/bin/bash
#shortcut for DEBUGINFO
DEBUGINFO=$(DI)
#skip updating of version/date of docs (internal option)
NOUPDOCS=$(ND)
#short cut for Address Sanitizer, internal only
ASAN=$(A)

#get pcre2 version and libs
PCRE2_VER:=$(shell pcre2-config --version)
PCRE2_LIBS:=$(shell pcre2-config --libs-posix)
#these must be the same (GG_PLATFORM_ID,GG_PLATFORM_VERSION) used in sys
OSNAME:=$(shell . ./sys; echo -n $${GG_PLATFORM_ID})
OSVERSION:=$(shell . ./sys; echo -n $${GG_PLATFORM_VERSION})
PGCONF:=$(shell ./sys pgconf)
DATE:=$(shell date +"%b-%d-%Y")
GG_OS_CLOSE_2:=$(shell grep OS_Close /usr/include/fcgios.h|grep shutdown|wc -l)

#these 2 must match application name from config file from each application

CC=gcc

#get build version and release, if .verstion not present, then empty
PACKAGE_VERSION:=$(shell . .version || true; echo $${PACKAGE_VERSION})



ifeq ($(strip $(PACKAGE_VERSION)),)
    PACKAGE_VERSION=2
endif

ifeq ($(strip $(GG_LOCAL)),1)
    GG_ROOT=$(DESTDIR)
else
    GG_ROOT=
endif

V_LIB=/usr/lib/golf
V_LIBD=/usr/lib/debug/golf
V_INC=/usr/include/golf
V_BIN=/usr/bin
V_MAN=/usr/share/man/man2

#see if man pages exist (or if not, need reindex)
MANEXIST:=$(shell if [ -d "$(V_MAN)" ]; then echo "1"; else echo "0"; fi)


V_GG_DATADIR=/usr/share
V_GG_DATADIR_GOLF=/usr/share/doc/golf

GG_SERVICE_INCLUDE=-I /usr/include/fastcgi

ifeq ($(strip $(PGCONF)),yes)
    GG_POSTGRES_INCLUDE:=-I $(shell pg_config --includedir) 
else
    GG_POSTGRES_INCLUDE:=$(shell  pkg-config --cflags libpq) 
endif

GG_MARIA_INCLUDE:=$(shell mariadb_config --include)
GG_MARIA_LGPLCLIENT_LIBS:=$(shell mariadb_config --libs) 
#$(shell mariadb_config --libs_sys)

GG_LIBXML2_INCLUDE:=$(shell pkg-config --cflags libxml-2.0)

#based on DEBUGINFO from debug file, we use appropriate tags
#Note: we always use -g in order to get line number of where the problem is
#(optimization is still valid though)
#if DEBUGINFO is 1, then no dbg files will be created, so delete any old ones as they wouldn't be accurate now
ifeq ($(DEBUGINFO),1)
    NONE:=$(shell rm -f *.dbg)
    CFLAGS_WARN_ERROR=-Werror 
    OPTIM_COMP=-g3 -DDEBUG -rdynamic
    OPTIM_LINK=-rdynamic
else
    CFLAGS_WARN_ERROR=
    OPTIM_COMP=-g3 -O3
    OPTIM_LINK=
endif
ifeq ($(ASAN),1)
    ASAN=-fsanitize=address -fsanitize-recover=address
else
    ASAN=
endif


#C flags are as strict as we can do, in order to discover as many bugs as early on
CFLAGS=$(CFLAGS_WARN_ERROR) -Wall -Wextra -Wuninitialized -Wmissing-declarations -Wformat -Werror=format-security -Wno-format-zero-length -funsigned-char -fpic -fno-semantic-interposition  $(GG_MARIA_INCLUDE) $(GG_POSTGRES_INCLUDE) $(GG_SERVICE_INCLUDE) $(GG_LIBXML2_INCLUDE) -DGG_OSNAME="\"$(OSNAME)\"" -DGG_OSVERSION="\"$(OSVERSION)\"" -DGG_PKGVERSION="\"$(PACKAGE_VERSION)\"" -DGG_ROOT="\"$(GG_ROOT)\"" $(OPTIM_COMP) $(ASAN) -fmax-errors=5 -Wdate-time -fno-stack-protector -fno-stack-clash-protection

#linker flags include mariadb (LGPL), crypto (OpenSSL, permissive license). This is for building object code that's part 
#this is for installation at customer's site where we link GOLF with mariadb (LGPL), crypto (OpenSSL)
LFLAGS_COMMON=-Wl,-z,relro
LFLAGS=-Wl,-rpath=$(DESTDIR)$(V_LIB) -Wl,--enable-new-dtags -L$(DESTDIR)$(V_LIB) $(OPTIM_LINK) $(LFLAGS_COMMON) $(ASAN)

#note that for make DI=1, DEBUGINFO can be checked. But we don't specify DEBUGINFO for sudo make install.
#then we wanted to have them all. Otherwise, none will be there, because we explicitly delete them here.
#If debugging build, no need to do anything, the executable is fully endowed with debugging symbols; but if
#not, then separate debugging info, and strip the executable and then link it to debugging info. The only
#exception is if this is debian build which does that (and lintian complains if we strip it ourselves).
define strip_sym
if [ "$(DEBUGINFO)" != "1" ]; then objcopy --only-keep-debug $@ $@.dbg || true ; if [[ "$(GG_DEBIAN_BUILD)" != "1" && "$(GG_FEDORA_BUILD)" != "1" ]]; then objcopy --strip-unneeded $@ || true ; objcopy --add-gnu-debuglink=$@.dbg $@ || true ; else rm -f $@.dbg || true ; fi ; fi
endef


#Libraries and executables must be 0755 or the packager (RPM) will say they are not satisfied
#SELinux directory is created and files put there just so if it ever gets selinux installed
#We only actually enable selinux polices if 1) not a fakeroot and 2) selinux actually installed (doesn't have to be enabled)
#SELinux can be enabled only if DESTDIR is empty, i.e. not a fake root. Otherwise, we're setting policies for fake root files, which of course doesn't work
#Per Debian guidelines, LICENSE file is not installed, as it's already in debian/copyright
#Man pages are installed dh_installman helper for Debian packaging, hence the guard for man page install below
#Man pages update (man-db) runs in any case in install, since it can run in fakeroot or otherwise
.PHONY: install
install:
	install -m 0755 -d $(DESTDIR)/var/lib/gg/bld
	install -m 0755 -d $(DESTDIR)$(V_INC)
	install -m 0755 -d $(DESTDIR)$(V_GG_DATADIR_GOLF)
	install -D -m 0644 golf.h -t $(DESTDIR)$(V_INC)/
	install -D -m 0644 gcli.h -t $(DESTDIR)$(V_INC)/
	install -m 0755 -d $(DESTDIR)$(V_LIB)
	install -m 0755 -d $(DESTDIR)$(V_LIB)/selinux
	install -D -m 0755 libgolfpg.so -t $(DESTDIR)$(V_LIB)/
	install -D -m 0755 libgolfdb.so -t $(DESTDIR)$(V_LIB)/
	install -D -m 0755 libgolflite.so -t $(DESTDIR)$(V_LIB)/
	install -D -m 0755 libgolfmys.so -t $(DESTDIR)$(V_LIB)/
	install -D -m 0755 libgolfsec.so -t $(DESTDIR)$(V_LIB)/
	install -D -m 0755 libgolftree.so -t $(DESTDIR)$(V_LIB)/
	install -D -m 0755 libgolfcurl.so -t $(DESTDIR)$(V_LIB)/
	install -D -m 0755 libgolfxml.so -t $(DESTDIR)$(V_LIB)/
	install -D -m 0755 libgolfarr.so -t $(DESTDIR)$(V_LIB)/
	install -D -m 0755 libgolfpcre2.so -t $(DESTDIR)$(V_LIB)/
	install -D -m 0755 libsrvcgolf.so -t $(DESTDIR)$(V_LIB)/
	install -D -m 0755 libgolf.so -t $(DESTDIR)$(V_LIB)/
	install -D -m 0755 libgolfcli.so -t $(DESTDIR)$(V_LIB)/
	install -D -m 0755 libgolfscli.so -t $(DESTDIR)$(V_LIB)/
	install -D -m 0644 stub_sqlite.o -t $(DESTDIR)$(V_LIB)/
	install -D -m 0644 stub_postgres.o -t $(DESTDIR)$(V_LIB)/
	install -D -m 0644 stub_mariadb.o -t $(DESTDIR)$(V_LIB)/
	install -D -m 0644 stub_gendb.o -t $(DESTDIR)$(V_LIB)/
	install -D -m 0644 stub_srvc.o -t $(DESTDIR)$(V_LIB)/
	install -D -m 0644 stub_pcre2.o -t $(DESTDIR)$(V_LIB)/
	install -D -m 0644 stub_curl.o -t $(DESTDIR)$(V_LIB)/
	install -D -m 0644 stub_arr.o -t $(DESTDIR)$(V_LIB)/
	install -D -m 0644 stub_tree.o -t $(DESTDIR)$(V_LIB)/
	install -D -m 0644 stub_crypto.o -t $(DESTDIR)$(V_LIB)/
	install -D -m 0644 stub_before.o -t $(DESTDIR)$(V_LIB)/
	install -D -m 0644 stub_after.o -t $(DESTDIR)$(V_LIB)/
	install -D -m 0644 stub_xml.o -t $(DESTDIR)$(V_LIB)/
	install -D -m 0644 golf.vim -t $(DESTDIR)$(V_LIB)/
	install -D -m 0644 vmakefile -t $(DESTDIR)$(V_LIB)/
	if [ "$(GG_DEBIAN_BUILD)" != "1" ]; then install -D -m 0644 LICENSE -t $(DESTDIR)$(V_GG_DATADIR_GOLF)/ ; fi
	install -D -m 0644 NOTICE -t $(DESTDIR)$(V_GG_DATADIR_GOLF)/
	install -D -m 0644 README.md -t $(DESTDIR)$(V_GG_DATADIR_GOLF)/
	install -D -m 0644 CONTRIBUTING.md -t $(DESTDIR)$(V_GG_DATADIR_GOLF)/
	install -m 0755 -d $(DESTDIR)$(V_BIN)
	install -D -m 0755 v1 -t $(DESTDIR)$(V_LIB)/
	install -D -m 0755 vdiag -t $(DESTDIR)$(V_LIB)/
	install -D -m 0755 gg  -t $(DESTDIR)$(V_BIN)/
	install -D -m 0755 mgrg  -t $(DESTDIR)$(V_BIN)/
	if [[ "$(GG_DEBIAN_BUILD)" != "1" && "$(GG_FEDORA_BUILD)" != "1" && -f v1.dbg ]]; then install -m 0755 -d $(DESTDIR)$(V_LIBD) ; install -D -m 0644 v1.dbg -t $(DESTDIR)$(V_LIBD)/ ; install -D -m 0644 mgrg.dbg  -t $(DESTDIR)$(V_LIBD)/ ;  install -D -m 0644 libgolfpg.so.dbg -t $(DESTDIR)$(V_LIBD)/ ; install -D -m 0644 libgolfdb.so.dbg -t $(DESTDIR)$(V_LIBD)/ ; install -D -m 0644 libgolflite.so.dbg -t $(DESTDIR)$(V_LIBD)/ ; install -D -m 0644 libgolfmys.so.dbg -t $(DESTDIR)$(V_LIBD)/ ; install -D -m 0644 libgolfsec.so.dbg -t $(DESTDIR)$(V_LIBD)/ ; install -D -m 0644 libgolftree.so.dbg -t $(DESTDIR)$(V_LIBD)/ ; install -D -m 0644 libgolfcurl.so.dbg -t $(DESTDIR)$(V_LIBD)/ ; install -D -m 0644 libgolfxml.so.dbg -t $(DESTDIR)$(V_LIBD)/ ; install -D -m 0644 libgolfarr.so.dbg -t $(DESTDIR)$(V_LIBD)/ ; install -D -m 0644 libgolfpcre2.so.dbg -t $(DESTDIR)$(V_LIBD)/ ; install -D -m 0644 libsrvcgolf.so.dbg -t $(DESTDIR)$(V_LIBD)/ ; install -D -m 0644 libgolf.so.dbg -t $(DESTDIR)$(V_LIBD)/ ; install -D -m 0644 libgolfcli.so.dbg -t $(DESTDIR)$(V_LIBD)/ ; install -D -m 0644 libgolfscli.so.dbg -t $(DESTDIR)$(V_LIBD)/ ; fi
	if [ "$(GG_DEBIAN_BUILD)" != "1" ]; then install -m 0755 -d $(DESTDIR)$(V_MAN) ; install -D -m 0644 docs/*.2gg -t $(DESTDIR)$(V_MAN)/ ; if [ "$(NOUPDOCS)" != "1" ]; then sed -i "s/\$$VERSION/$(PACKAGE_VERSION)/g" $(DESTDIR)$(V_MAN)/*.2gg; fi ; if [ "$(NOUPDOCS)" != "1" ]; then sed -i "s/\$$DATE/$(DATE)/g" $(DESTDIR)$(V_MAN)/*.2gg; fi ; for i in $$(ls $(DESTDIR)$(V_MAN)/*.2gg); do gzip -f $$i; done ; mandb >/dev/null 2>&1 || true ; fi
	install -D -m 0755 sys -t $(DESTDIR)$(V_LIB)/
#
#
#these settings must have GG_ROOT for installed files to work properly (i.e. to reference the correct path). GG_ROOT is not the same as DESTDIR. GG_ROOT is the root directory of a local install, while DESTDIR is a 'fake root' for building.
	sed -i "s|^[ ]*export[ ]*GG_LIBRARY_PATH[ ]*=.*|export GG_LIBRARY_PATH=$(GG_ROOT)$(V_LIB)|g" $(DESTDIR)$(V_LIB)/sys
	sed -i "s|^[ ]*export[ ]*GG_LIBRARY_PATH[ ]*=.*|export GG_LIBRARY_PATH=$(GG_ROOT)$(V_LIB)|g" $(DESTDIR)$(V_BIN)/gg
	sed -i "s|^[ ]*export[ ]*GG_INCLUDE_PATH[ ]*=.*|export GG_INCLUDE_PATH=$(GG_ROOT)$(V_INC)|g" $(DESTDIR)$(V_LIB)/sys
	sed -i "s|^[ ]*export[ ]*GG_VERSION[ ]*=.*|export GG_VERSION=$(PACKAGE_VERSION)|g" $(DESTDIR)$(V_LIB)/sys
#For local installation, make sure golf.h and gcli.h have proper GG_ROOT set, so that even plain gcc building for a C client works (i.e. GG_ROOT is defined properly)
	if [ "$(GG_LOCAL)" == "1" ]; then sed -i 's|^export GG_ROOT=.*$$|export GG_ROOT="'$(GG_ROOT)'"|g' $(DESTDIR)/usr/bin/gg ; sed -i 's|^#define GG_ROOT .*$$|#define GG_ROOT "'$(GG_ROOT)'"|g' $(DESTDIR)/usr/include/golf/golf.h ; sed -i 's|^#\s*define GG_ROOT .*$$|#define GG_ROOT "'$(GG_ROOT)'"|g' $(DESTDIR)/usr/include/golf/gcli.h ; fi
#end of setting variables with GG_ROOT
#
#
	chmod -x *.so; chmod -x *.o
#This must be last, in this order, as it saves and then applies SELinux policy where applicable. 
#This runs during rpm creation or during sudo make install
#it does NOT run during rpm installation, there is post scriptlet that calls golf.sel to do that (GG_NO_SEL)
	install -D -m 0644 gg.te -t $(DESTDIR)$(V_LIB)/selinux 
	install -D -m 0644 golf.te -t $(DESTDIR)$(V_LIB)/selinux 
	install -D -m 0755 golf.sel -t $(DESTDIR)$(V_LIB)/selinux 
#this selinux.setup will be executed in rpm post section, and here (below) if this is a system with SELinux
#the text saved to selinux.setup does NOT use DESTDIR, since this script never runs in fake root, meaning if it does run, then DESTDIR is empty (which is
#sudo make install from source) or it runs during %post section when installing package. So in either case, not a fake root.
#This way we also have a script to re-run policy setup if something isn't right
	install -D -m 0755 selinux.setup -t $(DESTDIR)$(V_LIB)/selinux
#this has to be double negation because it's purpose is to prevent selinux setup in fake root, which is only from golf.spec rpmbuild where GG_NOSEL is set to 1
#also SELinux cannot be installed with local install since it requires root access to change policies. So for Fedora-like distros, local setup is for permissive only
#(or run the script below as root!)
	if [[ "$(GG_LOCAL)" != "1" && "$(GG_FAKEROOT)" != "1" && -f /etc/selinux/config ]]; then $(DESTDIR)$(V_LIB)/selinux/selinux.setup; fi

=== debian/changelog ===
golf (601.4.41-1) unstable; urgency=medium

  * New upstream release, stop using gcc option "-fcf-protection=full"
    to fix build failure

 -- Golf Team <team@golf-lang.com>  Sat, 7 Jun 2025 09:21:22 -0700

golf (601.4.37-1) unstable; urgency=medium

  * Build flags changes for relro, plus source upload.

 -- Golf Team <team@golf-lang.com>  Fri, 6 Jun 2025 14:31:07 -0700

golf (520-1) unstable; urgency=medium

  * Initial release.(Closes:1102267)

 -- Golf Team <team@golf-lang.com>  Sun, 20 Apr 2025 11:07:21 -0700

=== debian/control ===
#SPDX-License-Identifier: Apache-2.0
#Copyright 2018-2025 Gliim LLC.
#Licensed under Apache License v2. See LICENSE file.
#On the web http://golf-lang.com/ - this file is part of Golf framework.


Source: golf
Section: devel
Priority: optional
Maintainer: Golf Team <team@golf-lang.com>
#To install build dependencies:
#sudo apt update
#sudo apt -y install devscripts equivs build-essential lintian
#mk-build-deps -i -s sudo debian/control
#Build apt with debuild -us -uc -b (.deb in parent dir afterwards)
Build-Depends: libssl-dev,
 pkgconf,
 libxml2-dev,
 libcurl4-openssl-dev,
 libmariadb-dev,
 zlib1g-dev,
 libfcgi-dev,
 libpq-dev,
 libsqlite3-dev,
 libpcre2-dev,
 debhelper-compat(= 12)
Standards-Version: 4.7.2
Homepage: https://golf-lang.com
Vcs-Browser: https://salsa.debian.org/golf/golf
Vcs-Git: https://salsa.debian.org/golf/golf.git

Package: golf
Architecture: any
#libfcgi-bin is for cgi-fcgi utility
Depends: make,
 gcc,
 libssl-dev,
 pkgconf,
 libxml2-dev,
 libcurl4-openssl-dev,
 libmariadb-dev,
 zlib1g-dev,
 libfcgi-bin,
 libfcgi-dev,
 libpq-dev,
 libsqlite3-dev,
 libpcre2-dev,
 ${shlibs:Depends},
 ${misc:Depends}
Recommends: curl
Description: Programming language for web services
 Programming language, tools, framework and application server for
 web services, web applications and command-line programs. Golf is
 memory safe and high performance, with code that is easy to read
 and write.

=== debian/rules ===
#!/usr/bin/make -f
#SPDX-License-Identifier: Apache-2.0
#Copyright 2018-2025 Gliim LLC.

%:
	GG_DEBIAN_BUILD=1 dh $@

=== debian/watch ===
version=4
https://github.com/golf-lang/golf/tags .*/v?(\d.*)@ARCHIVE_EXT@
